/* merror.c */

#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<strings.h>
#include	<interrupt.h>
#include	<sys/dos.h>
#include	<sys/iocs.h>
#include	<sys/xstart.h>

#include	"twin.h"
#include	"merror.h"

#define	EXIT_OK			0
#define	EXIT_ERROR		1
#define	EXIT_WARNING	2

#define	KEY_A	0x01
#define	KEY_R	0x02
#define	KEY_I	0x04

/* őEBhETCY */
#define	WX	52
#define	WY	3

extern char ID_name[];
extern char ID_version[];

/* X^bNƃq[v͏Ȃ */
int _heapsize = 1024*10;
int _stacksize = 1024*2;

#define	MES_MAX	28
char *def_table[MES_MAX] = {
			"%a߂ %r΂ %iނ H ",
			"G[($%e)܂.",
			" PC = $%p SR = $%s SP=$%t",
			"  oXG[܂  ",
			"AhXG[܂",
			" Ȗ߂s܂ ",
			"     OŏZ܂       ",
			"  bgj߂s܂  ",
			"sq`ou߂s܂",
			"   ߂gp܂   ",
			" Interrupt܂",
			" ZpbP[Wo^ł ",
			"          ȃjbgԍw肵܂          ",
			"      fBXNĂ܂AĂ      ",
			"   foCXhCoɖȃR}hw肵܂   ",
			"                    bqbG[                    ",
			" fBXN̊Ǘ̈悪j󂳂Ă܂Agps\ł ",
			"                    V[NG[                    ",
			"            ȃfBAgp܂            ",
			"               ZN^܂               ",
			"            v^ȂĂ܂            ",
			"                   ݃G[                   ",
			"                   ǂݍ݃G[                   ",
			"              G[܂                  ",
			" veNg͂āAfBXNĂ ",
			"                 ݕs\ł                 ",
			"     t@CLᔽłBݎgpł܂B     ",
			NULL };

struct pcm_data {
	char *filename;
	void *buffer;
	int size;
};

/* PCMt@Cpe[u */
struct pcm_data pcm_table[MES_MAX];

char *mes_A = "`";
char *mes_R = "q";
char *mes_I = "h";
char *mes_non = "  ";
char *mes_table[MES_MAX];
char *win_title = "== G[EEBhE ==";
unsigned short cur_chr = L'';
struct _fntbuf *cur_fnt = NULL;

static char *MES_FILE = NULL;
static int old_vector;

/* core No. */
int TWINCORE_NO = -1;

/* XCb`w */
int opt_r = 0;
int opt_t = 0;

/* g̖O */
char *progname;

static int volatile error_level = 0;
static unsigned char *buffer;
static char os_cur;

/* ftHgw */
static short fontsize = 16;
static short wcolor = 1;
static short color = 3;

/* SRWX^̊荞݃}XN𐧌䂷 */
inline void sr_mask_off(void)
{
	asm("\tand.w\t#$f8ff,sr");
}

inline void sr_mask_on(void)
{
	asm("\tor.w\t#$0700,sr");
}

int key_wait(TWIN *win, int stat)
{
	int time, stime;
	int c, ret;

	/* A{[gtÕZbg */
	_iocs_abortrst();

	/* L[obt@̃NA */
	while (_iocs_b_keysns())
		c = _iocs_b_keyinp();

	if (opt_t) {
		/* ^C}[bA */
		*(unsigned char *)0xe88015 |= 0x20;
	}

	/* C[v */
	stime = _iocs_ontime() - 10;
	twincuron(win);
	while(1) {
		/* J[\_ŏ */
		time = _iocs_ontime() - stime;
		if (time < 0) {
			stime = _iocs_ontime();
			time = 0;
		} else {
			if (win->tcursw) {
				if (time > 60) {
					/* J[\ */
					stime = _iocs_ontime();
					twincuroff(win);
				}
			} else {
				if (time > 40) {
					/* J[\\ */
					stime = _iocs_ontime();
					twincuron(win);
				}
			}
		}

		/* L[ */
		if (_iocs_b_keysns()) {
			c = _iocs_b_keyinp();
			c &= 0xff;
			if ((c == 'A'||c == 'a') && stat&KEY_A) {
				ret = KEY_A;
				c = 'A';
				break;
			}
			if ((c == 'R'||c == 'r') && stat&KEY_R) {
				ret = KEY_R;
				c = 'R';
				break;
			}
			if ((c == 'I'||c == 'i') && stat&KEY_I) {
				ret = KEY_I;
				c = 'I';
				break;
			}
		}
	}
	twincuroff(win);

	/* ͂L[\ */
	twinputc(win, c);

	/* ^C}[bg邩ׂ */
	if ( *(unsigned char *)0xe88015 & 0x20 ) {
		/* Ƃ҂(\悤) */
		stime = _iocs_ontime();
		time = 0;
		while (time < 15) {
			time = _iocs_ontime() - stime;
		}
	}

	/* ]ȕNA */
	twinprint(win, "\x1b[u\x1b[0K");

	return ret;
}

char *get_message(int code, int *ip, struct pcm_data **vp)
{
	if ((code & 0x00ff) == 0x1f) {
		*ip = (KEY_A | KEY_R);
		*vp = &pcm_table[10];
		return mes_table[10];
	} else if (code >= 2 && code <= 8) {
		*ip = KEY_A;
		*vp = &pcm_table[3+(code-2)];
		return mes_table[3+(code-2)];
	} else if (code < 0x1000) {
		*ip = KEY_A;
		*vp = &pcm_table[1];
		return mes_table[1];
	} else if (code >= 0xfe00 && code <= 0xfeff) {
		*ip = KEY_A;
		*vp = &pcm_table[11];
		return mes_table[11];
	} else if (code >= 0x8000) {
		*ip = KEY_A;
		*vp = &pcm_table[1];
		return mes_table[1];
	} else if ((code & 0x00ff) > 0x0f) {
		*ip = KEY_A;
		*vp = &pcm_table[1];
		return mes_table[1];
	}

	*ip  = code&0x1000 ? KEY_A : 0;
	*ip |= code&0x2000 ? KEY_R : 0;
	*ip |= code&0x4000 ? KEY_I : 0;
	*vp = &pcm_table[12+(code & 0xff)-1];
	return mes_table[12+(code & 0xff)-1];
}

void ARIput(char *buf, char *mes, char *p_A, char *p_R, char *p_I)
{
	char ch;

	while (ch = *mes++) {
		if (ch != '%') {
			*buf++ = ch;
		} else {
			switch (*mes) {
				case 'a':
					while (*p_A) {
						*buf++ = *p_A++;
					}
					break;
				case 'r':
					while (*p_R) {
						*buf++ = *p_R++;
					}
					break;
				case 'i':
					while (*p_I) {
						*buf++ = *p_I++;
					}
					break;
				default:
					*buf++ = *mes;
			}
			mes++;
		}
	}
	*buf++ = '\0';
}

int hexput(char *p, register int value, short max)
{
	static char chr[] = "0123456789abcdef";

	p += max-1;
	while(max--) {
		*p-- = chr[value & 0xf];
		value >>= 4;
	}
	return 0;
}

void NUMput(char *buf, char *mes, unsigned int err, unsigned int pc,
				unsigned int sr, unsigned int sp)
{
	char ch;

	while (ch = *mes++) {
		if (ch != '%') {
			*buf++ = ch;
		} else {
			switch (*mes) {
				case 'e':
					hexput(buf, err, 4);
					buf += 4;
					break;
				case 'p':
					hexput(buf, pc, 8);
					buf += 8;
					break;
				case 's':
					hexput(buf, sr, 4);
					buf += 4;
					break;
				case 't':
					hexput(buf, sp, 8);
					buf += 8;
					break;
				default:
					*buf++ = *mes;
			}
			mes++;
		}
	}
	*buf++ = '\0';
}


void user_error(void)
{
	SET_FRAME(a5);
	PRAMREG(error_no,d7);
	PRAMREG(reg_a6,a6);

	TWIN *win;
	short x, y, wx = WX, wy = WY;
	short col = wcolor, fsize = fontsize;
	short type = WIN_MINT;
	short pcol = color;
	short tcol;
	unsigned short sr;
	unsigned int pc;

	char buf[128];
	char *str;
	int stat;
	char *p_A, *p_R, *p_I;
	struct pcm_data *pcm_data;

	int ret = 0;

	/* ܂荞݂֎~ */
	sr_mask_on();
	/* G[[`̃R[񐔂JEg */
	error_level++;

	str = get_message((error_no & 0xffff), &stat, &pcm_data);
	sr = *((unsigned short*)reg_a6);
	pc = *((unsigned int*)(reg_a6+2));
	p_A = (stat&KEY_A) ? mes_A : mes_non;
	p_R = (stat&KEY_R) ? mes_R : mes_non;
	p_I = (stat&KEY_I) ? mes_I : mes_non;

	/* tHgTCYlăZ^O */
	x = (768/(fsize/2)/2) - ((wx+2)/2);
	y = ((16*23)/fsize/2) - ((wy+2)/2);

	/* EBhE|C^mۂ */
	win = twinopen(x, y, wx, wy, col, fsize);

	/* J[\p^[AhX̐ݒ */
	if (cur_fnt != NULL) {
		win->tcurpat = cur_fnt;
	}

	/* ߂ẴR[ȂEBhẺۑ */
	if (error_level == 1) {
		/* obt@ݒ */
		win->tbufp = buffer;

		/* J[\ */
		os_cur = *((char *)0x992);		/* J[\\tO */
		_iocs_b_curoff();
	} else {
		win->tbufp = NULL;
	}

	/* EBhE\ */
	tcol = type==WIN_MINT ? col+0x08 : col;
	twindraw(win, type, win_title, tcol);

	/* bZ[W\Fݒ */
	twincolor(win, pcol);

	/* G[v\ */
	twinlocate(win, 0,0);
	NUMput(buf, str, (unsigned int)(error_no & 0xffff), pc,
			sr, (unsigned int)(reg_a6+4));
	twinprint(win, buf);

	/* WX^̒l\ */
	twinlocate(win, 0,1);
	NUMput(buf, mes_table[2], (unsigned int)(error_no & 0xffff), pc,
			sr, (unsigned int)(reg_a6+4));
	twinprint(win, buf);

	/* bZ[W̕\ */
	twinlocate(win, 0,2);
	ARIput(buf, mes_table[0], p_A, p_R, p_I);
	twinprint(win, buf);

	/* J[\ʒuۑ */
	twinprint(win, "\x1b[s");

	/* PCMo */
	if (pcm_data->buffer != NULL) {
		if (_iocs_adpcmsns) {
			/* ~ */
			_iocs_adpcmmod(0);
		}
		/* 15.6KHz, LR ŏo */
		_iocs_adpcmout(pcm_data->buffer, 0x0403, pcm_data->size);
	}

	/* 荞݂ăL[͂ */
	sr_mask_off();
	ret = key_wait(win, stat);

	/* ꉞ荞݃}XN */
	sr_mask_on();

	if (--error_level == 0) {
		/* lXgĂȂΕۑeLXg߂ */
		twinclear(win);
		twinclose(win);

		/* J[\߂ */
		if (os_cur) {
			_iocs_b_curon();
		}
	} else if (ret&KEY_A) {
		/* A{[gȂۑeLXg߂ */
		win->tbufp = buffer;
		twinclear(win);
		twincloseall();
		error_level = 0;

		/* J[\߂ */
		if (os_cur) {
			_iocs_b_curon();
		}
	} else {
		/* ȊO͕\ȂŖ߂ */
		twinclose(win);
	}

	/* d7 ɒlԂ */
	switch(ret) {
		case KEY_A:	error_no = 0;	_iocs_abortjob();	break;
		case KEY_R:	error_no = 1;	break;
		case KEY_I:	error_no = 2;	break;
	}

	/* 荞݃[`畜A */
	IRTE();
}

int s_strcmp(char *str1, char *str2)
{
	int i;
	int ssp;

	ssp = _dos_super(0);
	i = strcmp(str1, str2);
	if(ssp >= 0)
		_dos_super(ssp);
	return i;
}

void ID_print(void)
{
	_dos_print(ID_name);
	_dos_putchar(' ');
	_dos_print(ID_version);
	_dos_print(" (c) JACK\r\n");
}

void version(void)
{
	_dos_print(progname);
	_dos_putchar(' ');
	_dos_print(ID_version);
	_dos_print(" (c) JACK\r\n");
}

void usage(void)
{
	_dos_print("usage: ");
	_dos_print(progname);
	_dos_print(" [-tr] [-m file] [-f size] [-c color]\r\n");
}

void help(void)
{
	static char *help_message[] = {
		" -m file   bZ[Wt@C̎w",
		" -f size   tHgTCY̎w",
		" -c color  J[̎w",
		" -t        ^C}[bIɏ",
		" -r        풓",
		NULL
	};
	char **p = help_message;

	version();
	usage();
	while (*p) {
		_dos_print(*p++);
		_dos_print("\r\n");
	}
}

long str2long(char *str, char **endptr)
{
	int radix = 0;

	if (str[0] == '$') {
		str++;
		radix = 16;
	} else if (str[0] == '0' && (str[1] == 'b' || str[1] == 'B')) {
		str += 2;
		radix = 2;
	}
	return strtol(str, endptr, radix);
}

void getarg(int argc, char *argv[])
{
	int i;
	char *e;

	for (i = 1; i < argc; i++) {
		if (*argv[i] == '-') {
			while (*++argv[i]) {
				switch(*argv[i]) {
					case	'm':
						if (*++argv[i] == '\0' && i++ >= argc) {
							_dos_print("t@Cw肵Ă.\r\n");
							exit(EXIT_ERROR);
						}
						MES_FILE = argv[i];
						argv[i] += strlen(argv[i]) - 1;
						break;
					case	'f':
						if (*++argv[i] == '\0' && i++ >= argc) {
							_dos_print("tHgTCYw肵Ă.\r\n");
							exit(EXIT_ERROR);
						}
						fontsize = str2long(argv[i], &e);
						if (*e || !(fontsize == 12 || fontsize == 16 || fontsize == 24)) {
							_dos_print("tHgTCYُł.\r\n");
							exit(EXIT_ERROR);
						}
						argv[i] = --e;
						break;
					case	'c':
						if (*++argv[i] == '\0' && i++ >= argc) {
							_dos_print("J[w肵Ă.\r\n");
							exit(EXIT_ERROR);
						}
						color = str2long(argv[i], &e);
						if (*e || color < 0 || color > 15) {
							_dos_print("J[ُł.\r\n");
							exit(EXIT_ERROR);
						}
						argv[i] = --e;
						break;
					case	'r':
						opt_r = 1; break;
					case	't':
						opt_t = 1; break;
					case	'V':
						ID_print(); exit(EXIT_OK); break;
					case	'h':
						help(); exit(EXIT_ERROR); break;
					default:
						usage(); exit(EXIT_ERROR); break;
				}
			}
		} else {
			/* ܂AłłH */
			MES_FILE = argv[i];
		}
	}
}

void *x_malloc(size_t size)
{
	void *p;

	if (p = malloc(size))	return p;
	_dos_print("q[v̈悪܂.\r\n");
	exit(EXIT_ERROR);
}

void *x_strdup(char *str)
{
	void *p;

	p = strdup(str);
	if (p)	return p;
	_dos_print("q[v̈悪܂.\r\n");
	exit(EXIT_ERROR);
}

struct pcm_data *check_pcm_buffer(char *name, int num)
{
	int i;

	if (name == NULL) {
		return NULL;
	}

	for (i = 0; i < num; i++) {
		if (pcm_table[i].filename != NULL) {
			if (strcmp(pcm_table[i].filename, name) == 0) {
				return &pcm_table[i];
			}
		}
	}

	/* tȂ */
	return NULL;
}

void mes_set(void)
{
	int i;
	int c;
	int flag = 0;
	FILE *fp;
	FILE *pcm_fp;
	char buf[140];
	char tmp[140];
	char *p, *q;
	size_t pcm_size;
	struct pcm_data *pcm_data;

	/* pcm e[ȕ */
	for (i = 0; i < MES_MAX; i++) {
		pcm_table[i].filename = NULL;
		pcm_table[i].buffer = NULL;
		pcm_table[i].size = 0;
	}

	if (MES_FILE == NULL) {
		for (i = 0; i < MES_MAX; i++) {
			mes_table[i] = def_table[i];
		}
	} else {
		if ((fp = fopen(MES_FILE, "rt")) == NULL) {
			_dos_print("bZ[Wt@CI[vł܂.\r\n");
			exit(EXIT_ERROR);
		}
		i = 0;
		while(1) {
			fgets(buf, 140-1, fp);
			if (feof(fp) != 0)	break;
			switch (buf[0]) {
				case '\n':
					break;
				case '#':
					if (buf[1] != '\n' && flag == 0) {
						_dos_print("TITLE:");
						_dos_print(buf+1);
						_dos_putchar('\r');
						flag = 1;
					}
					break;
				case '[':
					p = buf+1;
					q = tmp;
					while (*p && *p != ']') {
						*q++ = *p++;
					}
					*q++ = '\0';
					win_title = x_strdup(tmp);
					break;
				case '{':
					p = buf+1;
					c = *p++;
					c &= 0xff;
					if ((c >= 0x80 && c <= 0x9f) || c >= 0xe0) {
						c <<= 8;
						c += (unsigned char)*p++;
					}
					if (*p != '}') {
						_dos_print("J[\Ɏwł͈̂ꕶł.\r\n");
						_dos_print("c𖳎܂.\r\n");
					}
					cur_chr = (unsigned short)c;
					break;
				case '"':
					if (i > MES_MAX) {
						_dos_print("bZ[W߂܂.\r\n");
						fclose(fp);
						exit(EXIT_ERROR);
					}
					p = buf+1;
					q = tmp;
					while (*p && *p != '"') {
						*q++ = *p++;
					}
					*q++ = '\0';
					mes_table[i] = x_strdup(tmp);
					while (*++p == ' ')
						;
					q = tmp;
					if (*p == ',') {
						while (*++p == ' ')
							;
						while (*p && *p != '\n') {
							*q++ = *p++;
						}
						*q++ = '\0';
						if ((pcm_data = check_pcm_buffer(tmp, i)) != NULL) {
							/* ɓǂݍݍςPCMt@C */
							pcm_table[i].filename = pcm_data->filename;
							pcm_table[i].buffer = pcm_data->buffer;
							pcm_table[i].size = pcm_data->size;
						} else {
							if ((pcm_fp = fopen(tmp, "rb")) == NULL) {
								_dos_print("PCMt@C ");
								_dos_print(tmp);
								_dos_print(" I[vł܂.\r\n");
								_dos_print("w𖳎܂.\r\n");
							} else {
								pcm_size = filelength(fileno(pcm_fp));
								if (pcm_size < 0) {
									_dos_print("PCMt@C̃TCY𓾂܂.\r\n");
									_dos_print("w𖳎܂.\r\n");
								} else {
									pcm_table[i].filename = x_strdup(tmp);
									pcm_table[i].buffer = x_malloc(pcm_size);
									pcm_table[i].size = pcm_size;
									if (fread(pcm_table[i].buffer, 1, pcm_size, pcm_fp) != pcm_size) {
										_dos_print("PCMt@C̓ǂݍ݂Ɏs܂.\r\n");
										_dos_print("w𖳎܂.\r\n");
										free(pcm_table[i].buffer);
										pcm_table[i].filename = NULL;
										pcm_table[i].buffer = NULL;
										pcm_table[i].size = 0;
									}
								}
								fclose(pcm_fp);
							}
						}
					}
					i++;
					break;
				default:
					_dos_print("bZ[Wf[^ُł.\r\n");
					fclose(fp);
					exit(EXIT_ERROR);
			}
		}
		fclose(fp);
	}
}

void vector_reset(int *ip)
{
	int ssp;
	struct _mep *mp;
	struct hu_psp *pp;

	/* HUMAN.SYS ̓X[p[oCÜɂ */
	ssp = _dos_super(0);

	/* _memcp = libc ݒ肷鎩PSP|C^ */
	mp = _memcp->parent_mp;

	/* Ԑ擪܂Őeǂ */
	while(mp->parent_mp != 0)
		mp = mp->parent_mp;

	/* mp = HUMAN.SYS Ă */
	pp = (struct hu_psp*)mp;

	/* libc  struct ł͒`ĂȂ̈ANZX */
	/* Ql:G̏( */
	while (pp != 0) {
		pp->trap14 = (void*)*ip;
		pp = pp->child_mp;
	}

	/* X[p[oCU畜A */
	if(ssp >= 0)
		_dos_super(ssp);
	return;
}

void core_end(void)
{
	if (TWINCORE_NO != -1) {
		/* twincore ̏I錾 */
		twinend(TWINCORE_NO);
		TWINCORE_NO = -1;
	}
}

int main(int argc, char* argv[])
{
	int adr;
	void (*func)();
	void (*func_core_end)();
	void (*keep_core_end)();
	char *name;
	char *version;
	int offset_name;
	int offset_version;
	int offset_coreend;
	int buffer_size;

	int *ip;

	progname = argv[0];

	/* p[^ */
	getarg(argc, argv);

	/* bZ[Wf[^ǂݍ */
	mes_set();

	/* J[\tHgݒ */
	cur_fnt = x_malloc(sizeof(struct _fntbuf));
	_iocs_fntget(fontsize/2, cur_chr, cur_fnt);

	/* eLXgۑobt@m */
	buffer_size = ((((WX+2)*(fontsize/2)+7)/8)*((WY+2)*fontsize)+4)*2;
	buffer = x_malloc(buffer_size);

	/* ʃp^[̃AhX𓾂 */
	func = user_error;
	func_core_end = core_end;
	name = ID_name;
	version = ID_version;

	/* ItZbg߂ */
	offset_name = (int)name - (int)func;
	offset_version = (int)version - (int)func;
	offset_coreend = (int)func_core_end - (int)func;

	/* ݂̏AhX𓾂 */
	adr = (int)_dos_intvcg(0x2e);

	if (opt_r == 0) {
		/* 풓 */
		if (adr < 0xC00000) {
			if (s_strcmp((char*)adr+offset_name, name) == 0 &&
			s_strcmp((char*)adr+offset_version, version) == 0) {
				_dos_print("ɏ풓Ă܂.\r\n");
				exit(EXIT_ERROR);
			}
		}

		/* twincore ̃`FbNJn錾 */
		if ((TWINCORE_NO = twininit()) < 0) {
			_dos_print("twincorepł܂\r\n");
			exit(EXIT_ERROR);
		}

		/* xN^ύX */
		old_vector = (int)_dos_intvcs(0x2e, user_error);
		_dos_print("풓܂.\r\n");

		/* 풓 */
		_dos_keeppr((int)_last - (int)_procp - 0xf0, 0);
	} else {
		/* 풓 */
		if (adr < 0xC00000) {
			if (s_strcmp((char*)adr+offset_name, name) != 0) {
				_dos_print("풓Ă܂.\r\n");
				exit(EXIT_ERROR);
			}
			if(s_strcmp((char*)adr+offset_version, version) != 0) {
				_dos_print("풓Ăo[WႢ܂.\r\n");
				exit(EXIT_ERROR);
			}
			/* xN^S߂(ΕKv) */
			ip = (int*)(adr + (int)&old_vector - (int)func);
			vector_reset(ip);

			/* 풓 core_end s */
			keep_core_end = (void(*)())(adr + offset_coreend);
			keep_core_end();

			/* */
			_dos_mfree((void*)(adr + (int)_procp - (int)func));
			_dos_print("܂.\r\n");
			return 0;
		}
		_dos_print("풓Ă܂.\r\n");
		exit(EXIT_ERROR);
	}
}
